#include <iostream>
#include <ctime>

#include "Fenetre.h"
#include "FenCodeGenere.h"

using namespace std;
int loop=0;
QString code;

Fenetre::Fenetre() : QWidget()
{
	setWindowIcon(QIcon("prog.bmp"));
	setWindowTitle("MDP Gnrator");
	setFont(QFont("digital", 12));
	
	
	//layout principal
	layoutPrincipal = new QVBoxLayout;

	layoutNom = new QFormLayout;
	nom = new QLineEdit;
	prenom = new QLineEdit;
	layoutNom->addRow("&Nom :", nom);
	layoutNom->addRow("&Prenom :", prenom);
	utilisateur = new QGroupBox("&Utilisateur :");
	utilisateur->setLayout(layoutNom);
	
	//1er layout : presentation du produit
	label = new QLabel("<strong>Gnrateur de mot de passe</strong> !<br />Cod par <strong>Micmic</strong> !<br />Version 2.0", this);
	label->setAlignment(Qt::AlignCenter);
	
	//2eme layout : choix
	box = new QGroupBox("Que voulez-vous &utiliser ?");
	
	//sous layout : radiobutton
	layoutChoix = new QVBoxLayout;
	
	utilis = new QRadioButton("mot de passe avec votre nom, prnom et caractres spc&iaux");
	maj = new QRadioButton("mot de passe n'utilisant que des &majuscules");
	min = new QRadioButton("mot de passe n'utilisant que des m&inuscules");
	num = new QRadioButton("mot de passe n'utilisant que des &chiffres");
	spe = new QRadioButton("mot de passe n'utilisant que des caractres &spciaux");
	mix = new QRadioButton("m&ot de passe utilisant des majuscules, minuscules, des chiffres\net des caractres spciaux");

	utilis->setChecked(true);
	
	layoutChoix -> addWidget(utilis);
	layoutChoix -> addWidget(maj);
	layoutChoix -> addWidget(min);
	layoutChoix -> addWidget(num);
	layoutChoix -> addWidget(spe);
	layoutChoix -> addWidget(mix);

	box->setLayout(layoutChoix);

	layoutLabel = new QVBoxLayout;
	
	nbCaract = new QLabel("<strong><br />Le programme va gnrer des mots de passe <br />"
		"de la longueur que vous prciserez ci dessous</strong><br />", this);
	layoutLabel->addWidget(nbCaract);
	nbCaract->setAlignment(Qt::AlignCenter);
	
	boxCaractere = new QGroupBox("Nombe de caractres pour votre mot de passe :");//contenant spinbox et Qlabel
	layoutCaractere = new QVBoxLayout; // layout contenant la spinbox
	
	perso = new QPushButton("&Personnaliser le nombre de caractres");	
	perso->setToolTip("choisir le nombre de caractre pour le mot de passe");
	perso->setFont(QFont("digital", 12));
	
	layoutCaractere->addSpacing(10);
	layoutCaractere->addWidget(perso);

	boxCaractere->setLayout(layoutCaractere);	

	layoutSpace = new QHBoxLayout;
	space = new QLabel("Le programme va vous proposer 10 mots de passe differents<br />");
	space->setAlignment(Qt::AlignCenter);
	layoutSpace ->addWidget(space);

	layoutGenerer = new QHBoxLayout;
	generer = new QPushButton ("&GENERER");
	generer->setFont(QFont("digital", 14));
    generer->setCursor(Qt::PointingHandCursor);
	generer->setToolTip("gnrer le mot de passe");
	layoutGenerer->addWidget(generer);

	layoutSpace2 = new QHBoxLayout;
	space2 = new QLabel("<br />");
	layoutSpace2->addWidget(space2);

	boutonsLayout = new QHBoxLayout;
	
	m_about = new QPushButton ("A &Propos");
	m_about->setToolTip(" propos");

	aide = new QPushButton("&Aide");
	aide->setToolTip("aide");

	m_quitter = new QPushButton( "&Quitter");
	m_quitter->setToolTip("Quitter");
	
	boutonsLayout->addWidget(m_about);
	boutonsLayout->addWidget(aide);
	boutonsLayout->addWidget(m_quitter);

	layoutPrincipal->addWidget(label);
	layoutPrincipal->addWidget(utilisateur);
	layoutPrincipal->addWidget(box);
	layoutPrincipal->addWidget(nbCaract);
	layoutPrincipal->addWidget(boxCaractere);
	layoutPrincipal->addLayout(layoutSpace);
	layoutPrincipal->addLayout(layoutGenerer);
	layoutPrincipal->addLayout(layoutSpace2);
	layoutPrincipal->addLayout(boutonsLayout);

	setLayout(layoutPrincipal);

	QObject::connect(m_quitter, SIGNAL(clicked()), qApp, SLOT(quit()));
	QObject::connect(m_about, SIGNAL(clicked()), this, SLOT(ouvrirAbout()));
	QObject::connect(aide, SIGNAL(clicked()), this, SLOT(Aide()));
	QObject::connect(generer, SIGNAL(clicked()), this, SLOT(genererCode()));
	QObject::connect(perso, SIGNAL(clicked()), this, SLOT(personnaliser()));
	  
}

void Fenetre::ouvrirAbout()
{
		
		QMessageBox::about(this,"MDP Gnrator", "Merci d'utiliser <strong>MDP Gnrator</strong>"
		"<br /><br />MDP Gnrator est un Gnrateur de mot de passe, "
		"<br />Dvelopp par Micmic : cod en c++ avec une interface produite avec Qt"
		"<br />Version 2.0, cod le 12 Janvier 2009 !"
		"<br /><br />vous pouvez gnrer des mots de passe, des cls WEP, WAP, de cryptage,etc....      ");
		setFont(QFont("digital", 12));
}


void Fenetre::genererCode()
{
	srand(time(NULL));
	//QString code;
	if(nom->text().isEmpty() || prenom->text().isEmpty())
	{
		QMessageBox::critical(this, "Erreur", "Veuillez entrer un nom et un prnom");
	}
	
	if(loop ==0)
	{
		QMessageBox::critical(this,"MDP Gnrator", "vous devez d'abord choisir le nombre de caractres");
	}

	else
	{
		if(utilis ->isChecked())
		{
			const char spe[] = {'&', '~', '#', '', '@', '', '$', '%', '', ''};  // max = 9
			int MAX =9, MIN=1;
			code = "Proposition de MDP : \n~~~~~~~~~~~~~~~~~~~~\n\n";
			for (int i=0; i < 10; i++)//loop = QLineEdit receuillant un nombre 
			{
				code += spe[(rand() % (MAX - MIN +1)) + MIN] + nom->text().left(loop) + spe[(rand() % (MAX - MIN +1)) + MIN] + prenom->text().left(loop) + spe[(rand() % (MAX - MIN +1)) + MIN];
				code += "\n";
			}
				
		}

		else if (maj ->isChecked())
		{
			int MAX = 25, MIN =1;
			const char maj[] = {'A', 'B', 'C', 'D','E', 'F', 'G', 'H', 'I', 'J',  // max = 25
							'K', 'L', 'M', 'N','O', 'P', 'Q', 'R', 'S', 'T',
							'U', 'V', 'W', 'X',	'Y', 'Z'};
	
			code = "Proposition de MDP : \n~~~~~~~~~~~~~~~~~~~~\n\n";
			for (int j=0; j<10; j++)
			{
				code+="\t";
				for (int i=0; i < loop; i++)//loop = QLineEdit receuillant un nombre 
				{
					code += maj[(rand() % (MAX - MIN + 1)) + MIN];
					code += " ";
				}
				code += "\n";
			}
		}
		else if (min->isChecked())
		{
			int MAX = 25, MIN =1;
			const char min[] = {'a','b', 'c', 'd', 'e','f', 'g', 'h', 'i', 'j',  // max = 25
							'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
							'u', 'v', 'w', 'x', 'y', 'z'};
			code ="Proposition de MDP : \n\n";
			for (int j=0; j<10; j++)
			{
				code+="\t";
				for (int i=0; i < loop; i++)
				{
					code += min[(rand() % (MAX - MIN + 1)) + MIN];
					code += " ";
				}
				code += "\n";
			}
		}
		else if(num->isChecked())
		{
			int MAX = 9, MIN =1;
			const char num[] = {'0', '1', '2', '3','4', '5', '6', '7', '8', '9'}; // max = 9
	
			code ="Proposition de MDP : \n\n";
			for (int j=0; j<10; j++)
			{			
				code+="\t";
				for (int i=0; i < loop; i++)
				{
					code += num[(rand() % (MAX - MIN + 1)) + MIN];
					code += " ";
				}
				code += "\n";
			}
		}
		else if(spe->isChecked())
		{
			int MAX = 9, MIN =1;
			const char spe[] = {'&', '~', '#', '', '@', '', '$', '%', '', ''};  // max = 9
	
			code ="Proposition de MDP : \n\n";
			for (int j=0; j<10; j++)
			{		
				code+="\t";
				for (int i=0; i < loop; i++)
				{
					code += spe[(rand() % (MAX - MIN + 1)) + MIN];
					code += " ";
				}
				code += "\n";
			}
		}
		else if(mix->isChecked())
		{
			int MAX = 70, MIN =1;
			const char mix[] = {'a','b', 'c', 'd', 'e','f', 'g', 'h', 'i', 'j',    // max = 70
							'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
							'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D',
							'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
							'O', 'P', 'Q', 'R', 'S', 'T','U', 'V', 'W', 'X',
							'Y', 'Z', '0', '1', '2', '3','4', '5', '6', '7',
							'8', '9', '&', '~', '#', '', '@', '', '$', '%', 
							'', ''};
			code ="Proposition de MDP : \n\n";
			for (int j=0; j<10; j++)
			{			
				code+="\t";
				for (int i=0; i < loop; i++)
				{
					code += mix[(rand() % (MAX - MIN + 1)) + MIN];
					code += " ";
				}
				code += "\n";
			}
		}
			

	FenCodeGenere *fenetreCode = new FenCodeGenere(code, this);
	fenetreCode->exec();
	}
}

void Fenetre::personnaliser()
{
	if (utilis->isChecked())
	{
		bool ok;
	    int i = QInputDialog::getInteger(this, tr("Personnaliser le mot de passe"),
			tr("nombre de caracteres:"), 1, 1, 10, 1, &ok);
		loop = i;
	}
	else if( maj->isChecked() || min->isChecked() || num->isChecked() || spe->isChecked() || mix->isChecked())
	{
		bool ok;
	    int i = QInputDialog::getInteger(this, tr("Personnaliser le mot de passe"),
			tr("nombre de caracteres:"), 1, 1, 50, 1, &ok);
		loop = i;
	}
}

void Fenetre::Aide()
{
	QMessageBox::about(this,"MDP Gnrator", "Merci d'utiliser <strong>MDP Gnrator</strong>"
		"<br /><br />1- Vous devez cocher une case pour choisir les caracteres dsirs"
		"<br />2- Cliquer sur \"Personnaliser le nombre de caracteres\""
		"<br />3- choisir le nombre dans la fenetre ouverte en cliquant sur les fleches haut et bas"
		"<br />4- Cliquer sur gnrer pour decouvrir les propositions de mot de passe");

}